#!/sbin/sh

TMP_DIR=/tmp/DataOnSD
SRC_DEV=/dev/block/platform/msm_sdcc.1/by-name/userdata
DST_DEV=/dev/block/mmcblk1p2
VALID_TAG=".LGF6DataOnSD_DO_NOT_REMOVE"

EXIT_CODE=1
mkdir $TMP_DIR
mkdir $TMP_DIR/dst
mount -t ext4 -o rw $DST_DEV $TMP_DIR/dst
if [[ "$?" = "0" ]]; then
  if [[ ! -f $TMP_DIR/dst/$VALID_TAG ]]; then
    mkdir $TMP_DIR/src
    mount -t ext4 -o ro $SRC_DEV $TMP_DIR/src
    if [[ "$?" = "0" ]]; then
      rm -r $TMP_DIR/dst/*
      rm -r $TMP_DIR/dst/.*
      tar -cp -C $TMP_DIR/src ./ | tar -xp -C $TMP_DIR/dst
      touch $TMP_DIR/dst/$VALID_TAG
      umount $TMP_DIR/src
      EXIT_CODE=0
    fi
    rmdir $TMP_DIR/src
  fi
  umount $TMP_DIR/dst
fi
rmdir $TMP_DIR/dst
rmdir $TMP_DIR
exit $EXIT_CODE
